import { html, when } from '@microsoft/fast-element';
import { JSONForms } from './jsonforms/json-forms';
import { ArrayListWrapper } from './jsonforms/renderers/ArrayListWrapperRenderer';
import { CategorizationWrapper } from './jsonforms/renderers/CategorizationWrapperRenderer';
import { ControlWrapper } from './jsonforms/renderers/ControlWrapperRenderer';
import { DispatchRenderer } from './jsonforms/renderers/dispatch-renderer';
JSONForms;
ArrayListWrapper;
CategorizationWrapper;
ControlWrapper;
DispatchRenderer;
/** @beta */
export const foundationFormTemplate = html `
  <template>
    <json-forms
      ?readonly=${(x) => x.readonly}
      ?submitted=${(x) => x.submitted}
      :renderers=${(x) => x.renderers}
      :uischema=${(x) => x.uischema}
      :schema=${(x) => x.jsonSchema}
      :data=${(x) => x.data}
      @data-change=${(x, c) => x.onChange(c.event)}
    ></json-forms>
    ${when((x) => !x.readonly, html `
        <slot name="userActions" part="userActions" class="actions">
          <fast-button
            @click="${(x) => x._submit()}"
            ?disable=${(x) => !x.submitting}
            class="submit-button"
            appearance="accent"
          >
            Submit
          </fast-button>
        </slot>
      `)}
  </template>
`;
